/*
@Phigsdef
*/

#ifndef H_PHIGS_DEF
#define H_PHIGS_DEF

#ifndef H_MUSEDEF
#include "musedef.h"
#endif

/***************************************************************
@PHIGS #Defines
****************************************************************
*/

#define PMARKER_DOT      1
#define PMARKER_PLUS     2
#define PMARKER_ASTERICK 3
#define PMARKER_CIRCLE   4
#define PMARKER_CROSS    5

#define PLINE_SOLID      1
#define PLINE_DASH       2
#define PLINE_DOT        3
#define PLINE_DOT_DASH   4

#define BLACK            0
#define WHITE            1
#define RED              2
#define GREEN            3
#define BLUE             4
#define YELLOW           5
#define CYAN             6
#define MAGENTA          7

#define PLINE            0
#define PMARKER          1
#define PTEXT            2

/*
Description:
*/

/*
@PHIGS Simple Data Types
*/

/*
@    Pconnid
*/
typedef char* Pconnid;

/*
@    Pfloat
*/
typedef double Pfloat;

/*
@    Pint
*/
typedef long  Pint;

/*
@    Pmatrix
*/
typedef Pfloat Pmatrix[3][3];


/*
@PHIGS Complex Data Types
*/

/***************************************************************
@    Pint_size
****************************************************************
A PHIGS size structure
*/
typedef struct
{
    Pint size_x;
    Pint size_y;
} Pint_size;
/*
Description:

*/

/***************************************************************
@    Pint_list
****************************************************************
A PHIGS size structure
*/
typedef struct
{
    Pint num_ints;
    Pint *ints;
} Pint_list;
/*
Description:

*/

/***************************************************************
@    Plimit
****************************************************************
A PHIGS size structure
*/
typedef struct
{
    Pfloat x_min;
    Pfloat x_max;
    Pfloat y_min;
    Pfloat y_max;
} Plimit;
/*
Description:

*/

/***************************************************************
@    Ppat_rep
****************************************************************
A structure containing a strechable image
*/
typedef struct
{
    Pint_size dims;
    /* JLL 5/29 BYTE*/ unsigned char pHMEM colr_array;
    Pint pix_per_byte;
} Ppat_rep;
/*
Description:

*/

/***************************************************************
@    Ppoint
****************************************************************
A PHIGS point
*/
typedef struct
{
    Pfloat x;
    Pfloat y;
} Ppoint;
/*
Description:

*/
/***************************************************************
@    Ppoint_list
****************************************************************
A list of Phigs points
*/
typedef struct
{
    Pint   num_points;
    Ppoint *points;
} Ppoint_list;
/*
Description:

*/

/***************************************************************
@    Prect
****************************************************************
A PHIGS rectangle
*/
typedef struct
{
    Ppoint p;
    Ppoint q;
} Prect;
/*
Description:

/***************************************************************
@    Pregen_flag
****************************************************************
A PHIGS regeneration flag
*/
typedef enum
{
    PFLAG_PERFORM,
    PFLAG_POSTPONE
} Pregen_flag;
/*
Description:
The PGLAG_POSTPONE value will defer updates to the PHIGS
workstation.
*/

/***************************************************************
@    Pupd_st
****************************************************************
The current update state
*/
typedef enum
{
    PUPD_NOT_PEND,
    PUPD_PEND
} Pupd_st;
/*
Description:

*/

/***************************************************************
@    Pvec
****************************************************************
A PHIGS relative position
*/
typedef struct
{
    Pfloat delta_x;
    Pfloat delta_y;
} Pvec;
/*
Description:

*/

#endif /* H_PHIGS_DEF */






