/*
 * Copyright 1994, 1995 Vectaport Inc., Cartoactive Systems, Cider Press
 *
 * Permission to use, copy, modify, distribute, and sell this software and
 * its documentation for any purpose is hereby granted without fee, provided
 * that the above copyright notice appear in all copies and that both that
 * copyright notice and this permission notice appear in supporting
 * documentation, and that the names of the copyright holders not be used in
 * advertising or publicity pertaining to distribution of the software
 * without specific, written prior permission.  The copyright holders make
 * no representations about the suitability of this software for any purpose.
 * It is provided "as is" without express or implied warranty.
 *
 * THE COPYRIGHT HOLDERS DISCLAIM ALL WARRANTIES WITH REGARD TO THIS
 * SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS.
 * IN NO EVENT SHALL THE COPYRIGHT HOLDERS BE LIABLE FOR ANY SPECIAL,
 * INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING
 * FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT,
 * NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION
 * WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 * 
 */

/* Class wrapper for vpf database object */

#ifndef vpfdb_h
#define vpfdb_h

#include <Map/mapdb.h>
#include <Vpf/vpf.h>

class VpfLibrary;

class VpfDatabase : public MapDatabase {
public:
    VpfDatabase (const char *path, boolean init = true);
    virtual ~VpfDatabase ();

    VpfLibrary* library(unsigned libnum) const;
    VpfLibrary* library(const char*) const;

    virtual const char* description() const;
    void init();
    const char* producer() const;

    void print() const;

protected:
    virtual char** library_names(int& nlibs) const;
    virtual MapLibrary* make_library(const char* name);

protected:
    char* _dbprod;
    char* _dbdesc;
};

#endif /* defined(vpfdb_h) */
