/*
 * Copyright 1994, 1995 Vectaport Inc.
 *
 * Permission to use, copy, modify, distribute, and sell this software and
 * its documentation for any purpose is hereby granted without fee, provided
 * that the above copyright notice appear in all copies and that both that
 * copyright notice and this permission notice appear in supporting
 * documentation, and that the names of the copyright holders not be used in
 * advertising or publicity pertaining to distribution of the software
 * without specific, written prior permission.  The copyright holders make
 * no representations about the suitability of this software for any purpose.
 * It is provided "as is" without express or implied warranty.
 *
 * THE COPYRIGHT HOLDERS DISCLAIM ALL WARRANTIES WITH REGARD TO THIS
 * SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS.
 * IN NO EVENT SHALL THE COPYRIGHT HOLDERS BE LIABLE FOR ANY SPECIAL,
 * INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING
 * FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT,
 * NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION
 * WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 * 
 */

/* Class wrapper for vpf tiled feature class object */

#ifndef vpf_tiledfc_h
#define vpf_tiledfc_h

#include <Vpf/vpffclass.h>

class VpfTiledFeatureClass : public VpfFeatureClass {
public:
    VpfTiledFeatureClass(VpfCoverage*, const char* name, const char* =nil);
    virtual ~VpfTiledFeatureClass();
    int nfeats(int tileid);
    VpfFeature* feature(int tileid, int fnum);
protected:
    /* Ok, so this may be end up being DCW specific, but let\'s
       give it a shot */
    int* tilelen;
    int* tilestart;
    int* tileend;
    int _ntiles;
    VpfFeature*** _tfeatures;
    char* _tilename;
    virtual MapFeature** make_features(int &nfeats) const;
    void init_tile(int tileid);
    void make_tile_features(int tileid);
};

#endif
